#   1.6:
#   ,   
library(vegan) #   vegan    
source("print_rezult.r")  #    
# -------------------
#  ,    
#  :  indName -  ; data -  
indiv <- function (indName, data) { 
 if (indName=="shannon") ind <- diversity(data)		      #   
 if (indName=="simpson") ind <- diversity(data,"simpson")    #  
 if (indName=="alpha") ind <- fisher.alpha(data) 		     #    
 return (ind) }   
#  ,   -  
#  : method -  , permutations -   
 ici <- function(indName, data , method = 1, permutations=5000,Hist=FALSE) 
 { boots <- numeric(permutations) ; data <- data[data>0] #   = 0
  results <- numeric(4) ;   for (i in 1:length(boots)) {
## -----       
  if (method == 1) boots[i] <- indiv(indName, sample(data,replace=TRUE))
## ---  -,     ,
##          
  else { spn<-length(data) ; obs<-sum(data) #  
   probs<-data/obs   #     
temp.counts<-rep(1,spn)+ tabulate(sample(1:spn,obs-spn,prob=probs,replace=TRUE),nbins=spn)
   boots[i] <- indiv(indName, temp.counts)}
  }
div = indiv(indName, data) ; bias=mean(boots)-div ; results[1]<-div ; results[2]<-bias
CI <- quantile(boots, prob=c(0.025,0.975)) ; results[3]<-CI[1] ; results[4]<-CI[2]
  if (Hist)   {  hist(boots, main="", xlab = " ", col="grey", prob=TRUE)   
 abline(v= div, col = "red",lwd=2); abline(v= div+bias, col = "red",lwd=2,lty=2)
 abline(v= CI[1], col = "green",lwd=2) ; abline(v= CI[2], col = "green",lwd=2) } 
  return (results)
   }
#   
load (file="_.RData") #          
#       
TT ; div3 <- as.matrix(TT[,-1])  ; k = dim(div3)[2] 
ici("shannon", div3[,1], Hist=TRUE) ; ici("simpson", div3[,1], Hist=TRUE)
ici("shannon",method = 2,div3[,1], Hist=TRUE) 
#      
###   ("")
cdiv.results <-data.frame(rbind(Diversity = rep(NA, k),Bias = rep(NA, k),
low.Limit = rep(NA, k),upp.Limit = rep(NA, k))) ; names(cdiv.results) <- colnames(div3)
###   
for (i in 1:3) cdiv.results[,i] <- ici("shannon", div3[,i], method = 2)
cdiv.results ; pldat<-data.frame(t(cdiv.results)) ;  require(Hmisc)
errbar(x = c(1:3), y = pldat$Diversity+pldat$Bias, yplus = pldat$upp.Limit, 
		yminus = pldat$low.Limit, ylab = " ", 
		pch=15, xaxt="n", xlab="", xlim = c(0.5, 3.5))
axis(1,c(1:3),labels=row.names(pldat))
#      -   
TB <- div3[,1]  ;  TB <- TB[TB>0] ; n=length(TB)  #   
data.b<-t(replicate(20,
     sapply(
       lapply(c(100,300,1000,5000,10000), 
#    205  -  
function(i) replicate(i,indiv("shannon", sample(TB, replace=TRUE)))), 
			 function(i) mean(i)
#     ,      
#      
  #                 function(i)sqrt(var(i))  
  #                function(i) sort(i)[round(length(i)*0.025)])
  #                function(i) sort(i)[round(length(i)*0.975)])
                     )))
#     -   
plot(density(data.b[,1]), ylim=c(0,160),col="black", lwd=2)
lines(density(data.b[,3]),col="blue", lwd=2)
lines(density(data.b[,5]),col="red", lwd=2)
#   "  "    
boxplot(sapply(1:5, function (i) (abs(outer(data.b[,i], data.b[,i], FUN="-")
 [upper.tri(outer(data.b[,i], data.b[,i], FUN="-"))]))))
# -------------------
# ----  ABC-
#    (   )     
TB <- read.table("ABC_13.txt",header=T,row.names=1,sep="\t")
library(forams) #   forams   abc()   W- 
#  ,   - W-
#  : x -   abc; permutations -    
wci <- function(x, permutations=5000) { W <- function(v) { 
    return(round(sum(v)/ (50 * (length(v) - 1)), 4))}
  boots <- numeric(permutations)
  for (i in 1:length(boots)) {
    boots[i] <- W(sample(x$BiAi,replace=T))}
return (BootRes(boots, W(x$BiAi) ) ) }
wci(abc(TB))  #   
# -------------------
#     -
#   xls-     
# :  SubClass (), Genus (), Level ( )
library(xlsReadWrite)
TT <- read.xls("D://.xls", sheet = 1, rowNames=TRUE)
#  ,    
indoli <- function (data) { 
ind <- 100*sum(data[data$SubClass=="Oligochaeta" & data$Genus != "Nais", c("Level")])/sum(data$Level);  return (ind) } 
#  ,   -  J
olici <- function(data , permutations) 
 { boots <- numeric(permutations)
vyb <- t(replicate(permutations, sample.int(nrow(data), replace=TRUE)))
boots <- sapply(1:permutations, function (i) {l<-vyb[i,]; indoli(data[l,])})
  return (BootRes(boots, indoli(data))) }
olici(TT, 5000)   #   


