#   2.6:
#      
#        Y ()   F1,  as.factor
#  (,    )
#     (    )
anova_ub.1way <- function(Y, F1,  nperm=1000) {
mat = as.data.frame(cbind(Y,F1)); colnames(mat) <- c("Y","F1"); n = nrow(mat)
#       
F_emp <- oneway.test(Y~F1, data=mat, var.equal=F)$statistic ; GE = 1
#    F-     Y
for(j in 1:nperm)    {
      F_perm = oneway.test(sample(Y,n)~F1, data=mat, var.equal=F)$statistic 
      if(F_perm >= F_emp) GE = GE + 1 } 
return (list(oneway.test(Y~F1, data=mat, var.equal=F), paste(" () = ",GE/nperm))) }
#           
Len.body <- c(40,40,40,40,41,41,41,42,42,43,43,43,44,44,44,45,45,45,45,46,47,50,50,51,52,52,54,55,
55,55,56,56,57,57,57,50,46,42,56,50,46,55,54,54,54,47,55,47,52,51,55,50,48,47,55,49,45,54,46,47,45,
51,50,55,55,55,53,50,54,40,54,53,52,55,55,56,56,54,54,53,48,50,50,50,48,51)
Region <- as.factor(c(rep("",35), rep("",26), rep("",25)))
mat = as.data.frame(cbind(Len.body,Region))
#     
library(lawstat) 
levene.test(Len.body, Region,location="median")
##          -
shapiro.test.all <- matrix(data=NA, ncol=2, nrow=length(levels(Region)),
dimnames = list(paste("Region", levels(Region), sep = "="),c("W", "P")))
for ( j in 1:length(levels(Region)) ) {shapiro.test.each <- shapiro.test(Len.body[Region==levels(Region)[j]])
shapiro.test.all[j,1] <- shapiro.test.each$statistic ; shapiro.test.all[j,2] <- shapiro.test.each$p.value }
shapiro.test.all
#       :
(ant <- anova_ub.1way (Len.body,Region))
#          
m1 <- glm(Len.body ~ Region); summary(m1)
m0 <- glm(Len.body ~ 1) ; summary(m0); anova(m1, m0,test="Chisq")
#    
library(asbio); RF <- as.numeric(Region); RF <- as.factor(RF)
Pairw.test (y=Len.body,x=RF,method="LSD")     ##  LSD 
Pairw.test(y=Len.body,x=RF,method="Bonf")     ##  
Pairw.test(y=Len.body,x=RF,method="Scheffe")  ##  
Pairw.test(y=Len.body,x=RF,method="Tukey")    ##   HSD
#    
OL <- c(6.25,	5.5,	6.8,	11,	10.4,	11.85,	12.3,	7.6,	7.8,	12,	10,	10.5,	8.5,	7.5,	10,	10.3,
8.3,	8.7,	8.5,	8,	6.8,	8.8,	6,	7,	9.5,	6,	5.8,	4.4,	7.7,	8.6,	8.15,	5.2,	6.6,
6.6,	6,	3.7,	3.4,	5.6,	5.7,	5.6,	6.3,
10.5,	8.6,	5.3,	7.8,	10.8,	6.5,	10.7,	9.8,	11,	9.5,	9,	10.4,	13.3,	12)
M <- as.factor(c(rep(1,16),rep(2,25),rep(3,14)))
Pairw.test (y=OL,x=M,method="LSD")     ##  LSD 
Pairw.test(y=OL,x=M,method="Bonf")     ##  
Pairw.test(y=OL,x=M,method="Scheffe")  ##  
Pairw.test(y=OL,x=M,method="Tukey")    ##   HSD
