#    3.2:
#        
source("print_rezult.r")  #    
#     
Gast <- matrix(c(
270,  83,   15,   83,  2,    36,  1,    24,  4,    1,  3,  1,    0,  1,
448,  126,  69,  18,  15,  5,    22,  34,  48,  2,  0,  17,  0,  0,
639,  369,  58,  79,  26,  36,  23,  78,  37,  0,  0,  0,    4,  0,
173,  342,  6,    5,    6,    0,     0,   1,    1,    0,  0,  0,    3,  1)
, nrow=14, dimnames = list(Species = c("12345","1(23)45","10345","12045","12305","10045","12005","10005","10305","02045","00005","00000","1(23)(45)","123(45)"),
Sites = c("c","","","")))
#  ,      
rowTotals <- rowSums(Gast)  #     
colTotals <- colSums(Gast)  #     
nOfCases <- sum(rowTotals)  #   
Nrand = 1000
#  -------------     
#      2       stat
chisq.test(Gast)  #       
chisq.test(Gast, simulate.p.value = TRUE, B = Nrand) #     
#        2 (m -   ) 
chisq <- function(m) {
  ex <- margin.table(m, 1) %o% margin.table(m, 2) / sum(m)
  sum((m - ex)^2 / ex) }
#    .   r2dtable()   stat
simchi <- sapply(r2dtable(Nrand, rowTotals, colTotals), chisq)
RandRes(chisq(Gast), simchi, Nrand)  
#          --
#       |  (dat -   )
tau.CR <- function(dat)  {
  uncond <- nOfCases^2;    for(i in 1:nrow(dat))
     uncond <- uncond-nOfCases*sum(dat[i,]^2/rowTotals[i]);
      cond <- nOfCases^2-sum(colTotals^2); return (1-(uncond/cond)) }
simtau.CR <- sapply(r2dtable(Nrand, rowTotals, colTotals), tau.CR)
RandRes(tau.CR(Gast), simtau.CR, Nrand)
#       | 
tau.RC <- function(dat)  {
  uncond <- nOfCases^2;   for(j in 1:ncol(dat))
     uncond <- uncond-nOfCases*sum(dat[,j]^2/colTotals[j]);
  cond <- nOfCases^2-sum(rowTotals^2);
  return (1-(uncond/cond)) }
simtau.RC <- sapply(r2dtable(Nrand, rowTotals, colTotals), tau.RC)
RandRes(tau.RC(Gast), simtau.RC, Nrand)
#           -
#       |  (dat -   )
#  Ind   :   Ind =2    Ind =1
lambda <- function(dat, Ind = 1) {
L <- (sum(apply(dat, Ind, max)) - max(rowSums(dat))) / (sum(dat)-max(rowSums(dat)))
return (as.numeric(L))}
empLambda <- lambda(Gast)
simLambda <- sapply(r2dtable(Nrand, rowTotals, colTotals), lambda)
RandRes(lambda(Gast), simLambda, Nrand)
#           
#      (t -   )
P = function(t) {   
  r_ndx = row(t) ;   c_ndx = col(t)
  sum(t * mapply(function(r, c){sum(t[(r_ndx > r) & (c_ndx > c)])},  r = r_ndx, c = c_ndx))}
#    
Q = function(t) {
  r_ndx = row(t)  ;   c_ndx = col(t)
  sum(t * mapply( function(r, c){sum(t[(r_ndx > r) & (c_ndx < c)])},  r = r_ndx, c = c_ndx) )}
kendall_tau_c = function(t){ 
    t = as.matrix(t) ;  m = min(dim(t)) ;  n = sum(t)
    return(ks_tauc = (m*2 * (P(t)-Q(t))) / ((n^2)*(m-1))) }
simtau <- sapply(r2dtable(Nrand, rowTotals, colTotals), kendall_tau_c)
RandRes(kendall_tau_c(Gast), simtau, Nrand)
#  -------------   
#    
library(vegan)
#      (   2)
diversity2 <- function(x)  diversity(x,base=2)
DFA <- ncol(Gast)-1  
N0 <-(nOfCases  - sum(colTotals*colTotals)/nOfCases)/DFA   #       
T <- nOfCases*diversity2(rowTotals) #      
# -------   -
EDA <- function (data, invar=1) {
#   invar=1 -  Eta,   invar=2 -   
#     
   colH <- apply(data, 2, diversity2) ; R <- sum(colTotals*colH)
   F <- ((T-R)/DFA)/(R/(nOfCases-DFA-1)) ; Eta <- (F-1)/(F-1+N0)
	if (invar == 1)  return (Eta) 
       else if (invar == 2)  {
#      
  FackTable<- matrix(replicate(3*5, NA), nrow=3)
  rownames(FackTable) <- c(" ", " ","")
  colnames(FackTable) <- c(" ", " ", " ",
                                             "F-","")
  FackTable[3,1]= T; FackTable[2,1] = R ; FackTable[1,1] = T-R 
  FackTable[1,2]= DFA; FackTable[2,2] = nOfCases - DFA -1 ; FackTable[3,2] = nOfCases - 1
  FackTable[,3]= FackTable[,1]/FackTable[,2]; FackTable[1,4]=F ; FackTable[1,5]=Eta }
         return (FackTable) }
EDA(Gast, 2) 
# ---   
simEta <- sapply(r2dtable(Nrand, rowTotals, colTotals), EDA)
RandRes(EDA(Gast), simEta, Nrand)
# ----------------     ( )
#       (. . 3.3)      R
#   Fish <-read.delim("clipboard", row.names=1)
#         
load("fish.RData")
#        5   34   -  -
fisher.test(Fish, alternative="two.sided", simulate.p.value=TRUE, B=100000)
#     
rowTotals <- rowSums(Fish)  #     
colTotals <- colSums(Fish)  #     
nOfCases <- sum(rowTotals)  #   
Ncol = ncol(Fish)
Nrow = nrow(Fish)
total <-    c(23, 61, 33, 18, 17)     #  -  
Nrand=1000                                 #    
#       -
chisq_V <- function(X) {
m <-t(rbind(X,total-X)) ;   ex <- margin.table(m, 1) %o% margin.table(m, 2) / sum(m)
  sum((m - ex)^2 / ex)  }
#       ()  
B <- function(Y) { -sum(log((Nrand + 1.5 - Y)/(Nrand + 2))) }
#        -
Vran <- Rran <-matrix(rep(NA, Nrow*(Nrand+1)), nrow=Nrow)
for (i in 1:Nrow) Vran[i,1] = chisq_V(Fish[i,])
for (j in 1:Nrand) {
#     - FF
             Rm<-r2dtable(1, rowTotals, colTotals)[[1]]
             for (i in 1:Nrow) Vran[i,j+1] = chisq_V(Rm[i,]) }
#       
for (i in 1:Nrow) Rran[i,] <- rank(Vran[i,])
#            
Bf <- apply(Rran, 2, B)  ;  RandRes(Bf[1], Bf[2:(Nrand+1)] , Nrand)
