#    4.4:
#   ()  
#    xls- 
library(xlsReadWrite)
#   "-"
TTB <- t(read.xls("Manova.xls", sheet = 1, rowNames=TRUE))  
#  ""      
TTB.Site <- read.xls("Manova.xls", sheet = 2, rowNames=TRUE)  ; attach(TTB.Site)
#      
TTB.Coor <- read.table("Sok_coordinates.txt",header=F) ; colnames(TTB.Coor)<- c("X","Y")
rownames(TTB.Coor)<- c("_01","_03","_06","_07","_01","_02","_03","_05","_08","_10","_12","_14")
library(vegan)
Shennon <- diversity(exp(TTB)) #        
#       10     
T <- cbind(TTB.Site, Shennon) ; MShennon <- tapply(T$Shennon, T$Site, FUN=mean)
#        
#   ,       
plot(TTB.Coor, asp=1,  pch=21, col="white", bg="grey30", cex=5*MShennon/max(MShennon))
lines(TTB.Coor, lwd=2, col="blue") ; text(TTB.Coor, row.names(TTB.Coor), cex=0.5, col="white")
#       
save("TTB", "TTB.Coor", "TTB.Site", file="Sok.RData")
#  () ANOVA       
# (  D.Borcard, P.Legendre,2007)
River.f = as.factor(River)   #  
Site.f = as.factor(Site)     #  
dat = as.data.frame(cbind(Shennon, River.f, Site.f))
#   :       
balance = var(as.vector(table(dat[,2])))
if(balance > 0) stop(" . ")
#         
#       %in% 
anova.res = anova(lm(Shennon ~ River.f + Site.f %in% River.f))
if(nrow(anova.res)<3) cat("   (  ?)",'\n
',"      ",'\n')
#    F-      
F.main = anova.res[1,3] / anova.res[2,3]
P.main = pf(F.main, anova.res[1,1], anova.res[2,1], lower.tail=FALSE)
anova.res[1,4] = F.main ; anova.res[1,5] = P.main
#  
# ,      
restrictedPerm <- function(nobs.block, nblock, n, restPerm=TRUE, vec)
# restPerm == F:  .
# restPerm == T:   , ..     .
# :  toto0 <- restrictedPerm(6,4,24,FALSE,c(1:24))
#            toto1 <- restrictedPerm(6,4,24,TRUE, c(1:24))
{
if(restPerm == FALSE) { vec <- sample(vec[1:n],n)
   } else {
   for(j in 1:nblock) {
      i1 <- nobs.block*(j-1)+1 ;  i2 <- nobs.block*j
      vec[i1:i2] <- sample(vec[i1:i2],nobs.block)
      }    } 
return(vec) }
#  -------------------------------
nperm = 1000  
	n = nrow(dat) ; vec = seq(1:n) ; nblock = length(levels(River.f))
	nobs.block = nrow(dat)/nblock ; k = nrow(anova.res) - 1 ; 	Pperm = c(rep(0,k), NA)
#          
	if(nrow(anova.res)>=3){
	data2 = dat[order(dat[,2]),]  #       
		GEn = 1
		for(i in 1:nperm){
#   
			vecperm = restrictedPerm(nobs.block, nblock, n, restPerm=TRUE, vec) 
			Y.perm = data2[order(vecperm),1]
			anova.perm = anova(lm(Y.perm ~ River.f + Site.f %in% River.f))
			if(anova.perm[2,4] >= anova.res[2,4]) GEn = GEn + 1  }
    		Pperm[2] = GEn/(nperm+1)
               }
#     
	GEm = 1
	for(j in 1:nperm){
		Y.perm = sample(Shennon, n)
		anova.perm = anova(lm(Y.perm ~ River.f + Site.f %in% River.f))
		F.main.perm = anova.perm[1,3] / anova.perm[2,3]
		if(F.main.perm >= F.main) GEm = GEm + 1  }
   	     Pperm[1] = GEm/(nperm+1)
#   
anova.res  = data.frame(anova.res, Pperm)
colnames(anova.res) = c("Df", "Sum Sq", "Mean Sq", "F value", "Prob(param)", "Prob(perm)")
note = " ANOVA,    "
list(anova.type=note, nperm=nperm, anova.table=anova.res)  #  
#        
save (TTB, TTB.Site, file="Sok.RData")
