#    4.6:
#   :       
#       
load("Fito.RData") ; prednames <- names(Fito)[2:8] ; library(glmulti) ; library(MASS)
#         
obga <- glmulti("Bmass",xr=prednames,data=Fito,family = gaussian, level=2, method="g", marginality=TRUE, conseq=5,popsize=100,mutrate=1e-2)
BestFitoModel <- lm(formula = Bmass ~ 1 + Carb + Cl + Na + H + Na:Carb + H:Carb + H:Na, 
data = Fito) ; summary(BestFitoModel)
#         GAM
modGAM = gam(Bmass~s(Ca)+s(Carb)+s(Cl)+s(H)+s(Mg)+s(Na)+s(Sulfat), data=Fito)
summary(modGAM) ; anova(modGAM) ; plot(modGAM)
#       
DF1 <- apply( Fito[,2:8], 2,  log); colnames(DF1) <- paste("ln_",colnames(DF1), sep="")
DF2 <- apply( Fito[,2:8], 2,  sqrt); colnames(DF2) <- paste("sqr_",colnames(DF2), sep="")
DF3 <- apply( Fito[,2:8], 2,  exp); colnames(DF3) <- paste("exp_",colnames(DF3), sep="")
DF4 <- apply( Fito[,2:8],2,function(x) x*x); colnames(DF4) <- paste(colnames(DF4),"_2", sep="")
DF5 <- apply( Fito[,2:8],2,function(x) 1/x); colnames(DF5) <- paste("g1_",colnames(DF5), sep="")
DF6 <- apply( Fito[,2:8],2,function(x) exp(1/x)); colnames(DF6) <- paste("e1_",colnames(DF6), sep="")
Fito_R <- cbind(Fito, DF1, DF2, DF3, DF4, DF5, DF6)
#        
Model.Full <- lm(Bmass~., data=Fito_R) ; summary(Model.Full); AIC(Model.Full)
stepAIC(Model.Full,data=Fito_R,steps = 5000,trace = FALSE)  
#   -------------   -       ------------------
#  :         
estim.lm <- function (df, mask) {
fml <- as.formula(paste(names(df)[1],"~.")) ; df_sel <- df[,c(1,mask)]
return(lm(fml,df_sel)) }
#  :     "-"
adapt.lm <- function (probsVec,h, b.mask, w.mask) {
subVec = min(h, probsVec[w.mask]) ; probsNew <- probsVec ; probsNew[w.mask] <- probsNew[w.mask] - subVec
probsNew[b.mask] <- probsNew[b.mask] + mean(subVec); return (probsNew) 
} 
#  :      
rsa = function (df, maxNF=min(10, ncol(df)-1), d=5 , Tit = 20, N = 20, h=0.05) {
# :  maxNF -     
# d -    x  ; Tit -   
# N -       
# h -   (  ) 
#   -   
    n <- ncol(df)-1 ; p  <- as.numeric(rep(1/n, n)) ;  best.nF = 0
    for (nF in sample.int(maxNF,maxNF,T)) {
         for (iIt in 1:Tit) {
            test.mask = sort(unique(sample.int(n, nF, T, p) + 1))
            test.q = AIC(estim.lm(df, test.mask))
            if (best.nF == 0) {
              best.nF <- nF ; best.mask <- test.mask ; best.q <- test.q
              worst.mask <- test.mask ; worst.q <- test.q }
            else {  if (best.q > test.q) { best.nF <- nF ; best.mask <- test.mask ; best.q <- test.q }
               else if (test.q > worst.q) { worst.mask <- test.mask ; worst.q <- test.q } } 
         } 
        if (nF - best.nF > d)  break ; if  (h > 0)  p <- adapt.lm(p, h, best.mask-1, worst.mask-1)
   }   
return (estim.lm(df, best.mask)) }
#     
best.lm <- rsa(Fito_R, Tit = 100, N = 100,h=0.15) ; summary(best.lm) ; AIC(best.lm)
#     "Forward selection"   
library(FWDselect)
qob =qselection(x=Fito_R[,2:50],y=Fito_R[,1],qvector=c(1:14),method="lm",criterion="R2")
plot(qob)  #         
selection(x=Fito_R[,2:50],y=Fito_R[,1], q=7, criterion = "R2", method = "lm", family = "gaussian")
RegModel.7 <- lm(Bmass~ln_H+ln_Na+sqr_Carb+ln_Cl+H+e1_H+g1_Cl, data=Fito_R) ; summary(RegModel.7) ; AIC(RegModel.7

