#    4.7:
#   MANOVA    
#      Excel   
library(xlsReadWrite) ; PT <- read.xls(".xls", sheet = 1, rowNames=FALSE) 
F <- as.factor(findInterval(PT[,4],c(0,1966))) ; Y <- as.data.frame(PT[,5:8])
#    
#           
hotelling = function(y, f) {    #    : y -  , f -   
  k = ncol(y); y1 <- y[which(f==1),] ; y2 <- y[which(f==2),] ; n1 = nrow(y1); n2 = nrow(y2)
  ybar1= apply(y1, 2, mean); ybar2= apply(y2, 2, mean); diffbar = ybar1-ybar2
  v = ((n1-1)*var(y1)+ (n2-1)*var(y2)) /(n1+n2-2)       #     
  t2 = n1*n2*diffbar%*%solve(v)%*%diffbar/(n1+n2)   #    
  f = (n1+n2-k-1)*t2/((n1+n2-2)*k) ;  pvalue = 1-pf(f, k, n1+n2-k-1)  #    -
  return(list(pvalue=pvalue, f=f, t2=t2, diff=diffbar))   }
hotelling(Y, F)    #         
source("print_rezult.r") ; Nrand = 1000 ; reject = numeric(Nrand)   #    
for (i in 1:Nrand) {reject[i] = hotelling(Y, sample(F))$f}   #     F- 
RandRes(as.numeric(hotelling(Y, F)$f) , reject, Nrand)
library(Hotelling)  #      ,      Hotelling
split.data <- split(Y,F)  ;  summ.hots <- hotelling.stat(split.data[[1]], split.data[[2]])
summ.hot <- hotelling.test(split.data[[1]], split.data[[2]], perm = T, B = 1000)
#         :    
model11<-manova(cbind(BCAL, BCLA, BCYC,BROT)~Zone, data=PT)
model12<-manova(cbind(BCAL, BCLA, BCYC,BROT)~F, data=PT)
model<-manova(cbind(BCAL, BCLA, BCYC,BROT)~Zone*F, data=PT)
anova(model) ; summary(model,test="W"); summary(model,test="H") ; summary(model,test="R")
#    ----------------------------------------------------------------------
#      
A <- read.xls("1.xls", sheet = 1, rowNames=TRUE) ; A[is.na(A)] <- 0 ; n <-ncol(A) ; m <-nrow(A) 
Y <-1:n ; perm <- 300 ; tau <- numeric(perm)       #        
#   ,        
#    Skewer      ,   Skewer 
#     Ajv   m- 
Rast <- function (Ajv) {
XZ <- numeric(m) ; XZ[1] =  Skewer[1] * sum(Ajv*Skewer) / sq
for (i in 2:m) XZ[i] <- XZ[1] * Skewer[i] / Skewer[1]
return (sqrt(sum(XZ*XZ))) }
#        
for (ipa in 1:length(tau)) {
#   
Skewer <- runif(m, max=m); sq <- sum(Skewer*Skewer)
#         
X <- sapply(1:n, function (j) { Rast(as.vector(A[,j]))})
#    
tau[ipa] <- (cor(X,Y, method = "kendall")) }
#    (      t-)
hist(tau) ; mean(tau) ; tau ; 
mean(tau) - qt(0.975,perm - 1)*sqrt(var(tau)/perm); mean(tau) + qt(0.975,perm - 1)*sqrt(var(tau)/perm)

