#    5.4:
#         
library(xlsReadWrite)  #      Excel 
A <- read.xls("1.xls", sheet = 1, rowNames=TRUE)
library(ade4); library (vegan) ; library (cluster)
#     
A[is.na(A)] <- 0 ; A.norm <- decostand(t(A), "normalize"); spe.ch <- vegdist(A.norm, "euc")
#     
#     ,       (Single linkage)
spe.ch.single <- hclust(spe.ch, method="single") ; plot(spe.ch.single)
#     ,        (Complete linkage). 
spe.ch.complete <- hclust(spe.ch, method="complete") ; plot(spe.ch.complete)
#      (UPGMA -Unweighed pair-group  average) 
spe.ch.UPGMA <- hclust(spe.ch, method="average") ; plot(spe.ch.UPGMA)
#      ( Unweighed pair-group centroid). 
spe.ch.centroid <- hclust(spe.ch, method="centroid") ; plot(spe.ch.centroid)
#      (Ward's method).  
spe.ch.ward <- hclust(spe.ch, method="ward"); spe.ch.ward$height <- sqrt(spe.ch.ward$height); plot(spe.ch.ward)
#  Cophenetic correlation -   
spe.ch.single.coph <- cophenetic(spe.ch.single) ; mantel.rtest(spe.ch, spe.ch.single.coph,nrepet = 999)
spe.ch.comp.coph <- cophenetic(spe.ch.complete) ; mantel.rtest(spe.ch, spe.ch.comp.coph,nrepet = 999) 
spe.ch.UPGMA.coph <- cophenetic(spe.ch.UPGMA)  ;  mantel.rtest(spe.ch, spe.ch.UPGMA.coph,nrepet = 999) 
spe.ch.ward.coph <- cophenetic(spe.ch.ward)  ; mantel.rtest(spe.ch, spe.ch.ward.coph,nrepet = 999)    
#   
plot(spe.ch, spe.ch.single.coph, xlab=" ", 
  ylab=" ", asp=1, xlim=c(0,sqrt(2)), ylim=c(0,sqrt(2)), 
  main=c("  ",paste(" = ",   round(cor(spe.ch, spe.ch.single.coph),3))))
abline(0,1);lines(lowess(spe.ch, spe.ch.single.coph), col="red")
#         
g24 <- cutree(spe.ch.UPGMA, k = 1:5) ; table(grp2=g24[,"2"], grp4=g24[,"4"])
#     -  
spe.ch.kmeans <- kmeans(spe.ch, 4, nstart = 5 ) ; spe.ch.kmeans$cluster
plot(spe.ch, col = spe.ch.kmeans$cluster) ; points(spe.ch.kmeans$centers, col = 1:5, pch = 8)
#            - 
cont.table <- table(spe.ch.kmeans$cluster,as.vector(cutree(spe.ch.UPGMA, k = 4))) ; print(cont.table)
##       (   )
library(e1071) ; class.match <- matchClasses(as.matrix(cont.table),method="exact") ;  print(cont.table[,class.match])
#-------------------------
#       " "
plot(spe.ch.UPGMA$height, ncol(A):2, type="S", 	ylab="k ( )", xlab="h ( )", col="grey11")
text(spe.ch.UPGMA$height, ncol(A):2, ncol(A):2, col="red", cex=0.8)
#   ,     
#        
grpdist <- function(X)   {
  gr <- as.data.frame(as.factor(X)) ;   distgr <- daisy(gr, "gower") ;   distgr   } 
grpdist(cutree(spe.ch.UPGMA, 4))
# ,       
kt <- data.frame(k=1:ncol(A), r=0)
for (i in 2:(ncol(A)-1)) { 	gr <- cutree(spe.ch.UPGMA, i); distgr <- grpdist(gr)
	mt <- cor(spe.ch, distgr, method="pearson") ; 	kt[i,2] <- mt }
kt ; k.best <- which.max(kt$r)
#        
plot(kt$k, kt$r, type="h", xlab="k ( )", ylab=" ")
axis(1, k.best, paste("M", k.best, sep="\n"), col="red", font=2,	col.axis="red")
points(k.best, max(kt$r), pch=16, col="red", cex=1.5)
#  ""     
cutg <- cutree(spe.ch.UPGMA, k=4) ; sil <- silhouette(cutg, spe.ch)
silo <- sortSilhouette(sil) ; rownames(silo) <- col.names(A)[attr(silo,"iOrd")]
plot(silo, 	cex.names=0.8, col=cutg+1, nmax.lab=100)
#            
library(pvclust) ;     cluster.bootstrap <- pvclust(t(A.norm), nboot=1000, method.dist="euclidean")
summary(cluster.bootstrap) ; plot(cluster.bootstrap) ;  pvrect(cluster.bootstrap)
#          
library(scaleboot) ; fm <- sbfit(cluster.bootstrap) ; summary(fm) ; plot(fm,legend="topleft")

