#  	  5.5:
#      
#       (.    5.3)
load(file="Fito_Dmat.RData") ; ls() ; library(vegan) ; library (cluster) 
#  : D_spec -     
# Geo -    , Envir -    
#     Partitioning around medoids (PAM)
asw <- numeric(nrow(Species)) 
for (k in 2:(nrow(Species)-1)) ; 	asw[k] <- pam(D_spec, k, diss=TRUE)$silinfo$avg.width
k.best <- which.max(asw) ; cat("", "   k =", k.best, "\n", 
				"    S=", max(asw), "\n")
plot(1:nrow(Species), asw, type="h", xlab="k ( )", ylab="  ")
axis(1, k.best, paste("optimum",k.best,sep="\n"), col="red", font=2,col.axis="red")
points(k.best, max(asw), pch=16, col="red", cex=1.5) #    S
spe.ch.kmeans <- pam(D_spec, k=k.best, diss=TRUE); str(spe.ch.kmeans)
#         
plot(silhouette(spe.ch.kmeans),  cex.names=0.8, col=spe.ch.kmeans$silinfo$widths+1)
#      
KM <- spe.ch.kmeans$medoids ; countKM <- spe.ch.kmeans$clusinfo[,1] ;  
grKM <- spe.ch.kmeans$cluster
plot(Geo$Xc, Geo$Yc, asp=1, type="n", xlab="x  ()", ylab="y  ()")
for (i in 1:k.best) {  cex_var = 7*(countKM[i])/max(countKM)
    points(Geo[grKM==i,2], Geo[grKM==i,1], pch=21, cex=0.5, col=i+1, bg=i+1) 
    points(Geo[KM[i],2], Geo[KM[i],1], pch=21, cex = cex_var, bg=i+1, col="black")
    text(Geo[KM[i],2], Geo[KM[i],1], i, cex=1, font=3, col="black")    }
# legend("bottomright", paste(" ",1:k.best), pch=21,  col=2:(k.best+1),pt.bg=2:(k.best+1),
    pt.cex=2, bty="n")
#    (  -) 
#      k.best      
#    P. Legendre - http://www.bio.umontreal.ca/legendre/indexEn.html
source("anova.1way.R") ; Fac_clu <- as.factor(spe.ch.kmeans$cluster)
attach(Envir) ; La <- colnames(Envir); ANOVA_RES <-as.vector(rep(NA,length(La))) 
for (i in 1:ncol(Envir))  {  KW <- kruskal.test(Envir[,i] ~ Fac_clu)
ANOVA_RES[i] <-list(c(Envir=La[i], anova.1way(Envir[,i]~Fac_clu, nperm=999), 
Kruskal_Wallis =paste("chi squared = ", KW$statistic,"  p.value=", KW$p.value)))  }
#  ----------------------------------
#       (ANOSIM  MRPP)
Sign_clus <- function (k) { kmeans <- pam(D_spec, k, diss=TRUE); 
anoR <- anosim(D_spec, kmeans$cluster); mrppA <- mrpp(D_spec, kmeans$cluster); 
return (cat(" k =", k," ANOSIM  R =", anoR$statistic, " p =", anoR$signif, "\n",
" MRPP  A =", mrppA$A,  "()=", mrppA$delta, "()=", mrppA$E.delta, 
" p =", mrppA$Pvalue, "\n"))  }  
Sign_clus(4) ; Sign_clus(11) ; Sign_clus(18);  Sign_clus(40) ; Sign_clus(60)
