#    6.2:
#  I.      
#         
library(vegan)  ; load(file="Fito_Full.RData");  Species <- Species[,-8]
Species_stand<-decostand(Species,"standardize") #      decostand
# 1.   princomp
#    
prin_comp<-princomp(Species_stand) ; summary(prin_comp) ; ordiplot(prin_comp, type="text")
#    
prin_comp<-princomp(Species) ; summary(prin_comp) ; ordiplot(prin_comp, type="text")
# 2.   function prcomp (   )
prin_comp<-prcomp(Species,retx=FALSE,center=FALSE) ; summary(prin_comp) ; ordiplot(prin_comp, type="text")
# 3.   rda ( scale=TRUE   )
Spec.pca <- rda(Species, scale=FALSE) ; summary(Spec.pca, scaling=1) ; summary(Spec.pca, scaling=2) 
par(mfrow=c(1,2))  #  PCA :   1  2
source("cleanplot.pca.R")  #      biplot.rda()
biplot.rda(Spec.pca, scaling=1, main="PCA -  1", type = "text") 
biplot.rda(Spec.pca, scaling=2, main="PCA -  2", type = "text")  
#           
sigpca2<-function (x, permutations=1000, ...) {  # ,   
   pcnull <- princomp(x, ...) ;  res <- pcnull$loadings
   out <- matrix(0, nrow=nrow(res), ncol=ncol(res)) ;   N <- nrow(x)
   for (i in 1:permutations) {
       pc <- princomp(x[sample(N, replace=TRUE), ], ...)
       pred <- predict(pc, newdata = x) ;  r <-  cor(pcnull$scores, pred) ; k <- apply(abs(r), 2, which.max)
       reve <- sign(diag(r[k,])) ; sol <- pc$loadings[ ,k] ; sol <- sweep(sol, 2, reve, "*")
       out <- out + ifelse(res > 0, sol <=  0, sol >= 0) }
   out/permutations }                                
sigpca2(Species, permutations=1000)
#     
ev <- Spec.pca$CA$eig ; ev[ev > mean(ev)]  #  -
#    
n <- length(ev) ; bsm <- data.frame(j=seq(1:n), p=0); bsm$p[1] <- 1/n
for (i in 2:n) {bsm$p[i] = bsm$p[i-1] + (1/(n + 1 - i))} ; bsm$p <- 100*bsm$p/n
#         
par(mfrow=c(2,1)) ; barplot(ev, main=" ", col="bisque", las=2)
abline(h=mean(ev), col="red") 
legend("topright", "  ", lwd=1, col=2, bty="n")
barplot(t(cbind(100*ev/sum(ev),bsm$p[n:1])), beside=TRUE, main="% ",
 					col=c("bisque",2), las=2)
legend("topright", c("%  ", "  "),pch=15,
 col=c("bisque",2), bty="n")
#  II.       
library(xlsReadWrite)  #      Excel 
Bentos <- read.xls("1.xls", sheet = 1, rowNames=TRUE) ; Bentos[is.na(Bentos)] <- 0 
Bentos <- t(Bentos) ; Spec.pca <- rda(Bentos, scale=FALSE) ; summary(Spec.pca, scaling=1)
#       -
N.boot <- 1000 ; nObs = nrow(Bentos) ; nEig = 4 
ci.level = 0.95 ; prob.low = (1-ci.level)/2 ; prob.high = 1-prob.low 
boot.eigenval <- boot.eigenprop <- boot.eigencum <-  matrix(0, nrow=N.boot, ncol=nEig)  
for (iter in 1:N.boot)  { i = sample(1:nObs, replace=TRUE) 
boot.pca <- rda(Bentos[i,], scale=FALSE) ; boot.eigenval[iter,] = boot.pca$CA$eig[1:nEig]
boot.eigenprop[iter,] = boot.pca$CA$eig[1:nEig]/sum(boot.pca$CA$eig)
boot.eigencum[iter,] = cumsum(boot.pca$CA$eig[1:nEig]/sum(boot.pca$CA$eig)) }
CumSum <- cumsum(Spec.pca$CA$eig[1:nEig]/sum(Spec.pca$CA$eig)) ; 
Eval <-  matrix(0, nrow=nEig, ncol=9) 
colnames(Eval) <- c(". .", ".",".",".", ".",
".", ".", ".",".") 
for (k in 1:nEig) {
Eval[k,1]=Spec.pca$CA$eig[k]; Eval[k,2] = quantile(boot.eigenval[,k], probs=prob.low, na.rm = TRUE) 
Eval[k,3] = quantile(boot.eigenval[,k], probs=prob.high)
Eval[k,4]=Spec.pca$CA$eig[k]/sum(Spec.pca$CA$eig) 
Eval[k,5] = quantile(boot.eigenprop[,k], probs=prob.low) 
Eval[k,6] = quantile(boot.eigenprop[,k], probs=prob.high, , na.rm = TRUE)  
Eval[k,7]= CumSum[k]; Eval[k,8] = quantile(boot.eigencum[,k], probs=prob.low, , na.rm = TRUE) 
Eval[k,9] = quantile(boot.eigencum[,k], probs=prob.high, , na.rm = TRUE) } ; Eval
#       ()
boot  <- function(data) data[sample(1:nrow(data),size=nrow(data),replace=T),]
#      ""  ()
boot2 <- function(data) apply(data,2,function(x) x[sample(1:length(x),size=length(x),replace=T)])
#       -  r2dtable
boot1 <- function(data) r2dtable(1, rowSums(data), colSums(data))[[1]]
#      
plot(Spec.pca$CA$eig, pch=16, type="b",ylab="C ",
 xlab=" ", xlim=c(1,8))
    for(i in 1:100) lines(rda(boot2(Bentos),scale=FALSE)$CA$eig, col="red") 
    for(i in 1:100) lines(rda(boot(Bentos),scale=FALSE)$CA$eig, col="grey") 
    for(i in 1:100) lines(rda(boot1(Bentos),scale=FALSE)$CA$eig, col="green") 
  points(Spec.pca$CA$eig, type="b", lwd=2)  #      
#     
plot(Spec.pca, dis = "sites", type = "n")    #    ( )
ordipointlabel(Spec.pca, display = "sites", font=4,  pch=21,  bg="grey")
plot(Spec.pca,  dis = "sp", type = "n")    #    ( )
stems <- colSums(Bentos)  ; ordilabel(Spec.pca, dis = "sp", priority=stems)
