#    6.6:   MANOVA      
library(xlsReadWrite) ; GM <- read.xls("Ruts.xls", sheet = 2, rowNames=TRUE) 
#          m 2 n
conf_mat <- function (df, m, n)  { cm <- array(rep(0,m*2*n),dim=c(m,2,n))
for (i in 1:n) { for (j in 1:m) {cm[j,1,i] = df[i,j*2-1]; cm[j,2,i] = df[i,j*2]}} ; cm } 
#    :        
m <- 6 ; ruts.cm <- conf_mat(GM[,3:14], m, nrow(GM)) 
A.cm <- ruts.cm[,,which(GM$sex =="F")] ; B.cm <- ruts.cm[,,which(GM$sex =="M")] 
dim(A.cm) ; dim(B.cm) ; dim(ruts.cm)  ; library(shapes)
#             
A.cm <- ruts.cm[,,which(GM$region ==1)] ; B.cm <- ruts.cm[,,which(GM$region != 1)]
#  MANOVA       
model11<-manova(cbind(X1,Y1,X2,Y2,X3,Y3,X4,Y4,X5,Y5)~sex, data=GM)
model12<-manova(cbind(X1,Y1,X2,Y2,X3,Y3,X4,Y4,X5,Y5)~region, data=GM)
model<-manova(cbind(X1,Y1,X2,Y2,X3,Y3,X4,Y4,X5,Y5)~sex*region, data=GM)
anova(model) ; summary(model,test="W"); summary(model,test="H") ; summary(model,test="R")
#         ''  ''  . 6.17 
book.ruts <- bookstein2d(ruts.cm, 5, 1) ; segments(-0.5,0,0.5,0, col="blue",lwd=3) ; book.ruts$mshape
book.A <-bookstein2d(A.cm, 5, 1) ; book.B <-bookstein2d(B.cm, 5, 1)
book.A$mshape ; book.B$mshape
plotshapes(book.A$mshape,joinline=c(1,2,4,5,3,6,1), symbol="") 
lines(book.B$mshape[c(1,2,4,5,3,6,1),],lty=2) 
text(book.A$mshape,  "\\VE", family = "HersheySerif") #      Female
text(book.B$mshape,  "\\MA", family = "HersheySerif")  #      Male
#     
proc.ruts =procGPA(ruts.cm) ; proc.A <-procGPA(A.cm)  ;  proc.B <-procGPA(B.cm) 
plotshapes(proc.ruts$rotated, joinline=c(1,2,4,5,3,6,1))  #  . 6.17 
plotshapes(proc.ruts$mshape, joinline=c(1,2,4,5,3,6,1)) #  () 
mean(proc.ruts$size) ; mean(proc.A$size) ; mean(proc.B$size) #    
riemdist(proc.A$mshape, proc.B$mshape)  #    
testmeanshapes(A.cm, B.cm, resamples=1000)  #        
shape_variables<-t(matrix(proc.ruts$rotated,m*2,nrow(GM)))
#    PCA   
shapepca(proc.ruts, pcno = c(1, 2), type = "v",mag=3) 
shapepca(proc.ruts, pcno = c(1, 2), type = "r",mag=3)  
#   -     rda()   vegan
library(vegan) ; pca.ruts<-rda(shape_variables) ; summary(pca.ruts)
plot(proc.ruts$scores[,1],pca.ruts$CA$u.eig[,1]) #      
#          
plot(pca.ruts$CA$u.eig[,1],pca.ruts$CA$u.eig[,2],pch=16, col=c("red","blue")[GM$sex])
#   MANOVA    8  
response_matrix<-cbind(pca.ruts$CA$u.eig[,1:8]) ; model<-manova(response_matrix~GM$sex)
anova(model) ; summary(model,test="W"); summary(model,test="H") ; summary(model,test="R")
library(heplots) ; etasq(model)  #    eta^2
save(file="GM.RData",GM, shape_variables, response_matrix) #        6.7 
