#    6.7:   ,      
load(file="GM.RData")   #  ,      6.6 
Gr <- as.factor(GM[,1]) ; DS <- cbind(GM[c(1,15:17)],response_matrix) ; attach(DS) 
library(MASS) #  -------------     LDA   QDA 
#    
Out_CTab <- function (model, group, type="lda") {
#    "/"      
classified<-predict(model)$class  ; t1 <-  table(group,classified)  
#      
Err_S <- mean(group != classified) ; mahDist <- NA
if (type=="lda") { mahDist <- dist(model$means %*% model$scaling) }
#   "/"        
t2 <-  table(group, update(model, CV=T)$class->LDA.cv) ; Err_CV <- mean(group != LDA.cv)
Err_S.MahD  <-c(Err_S, mahDist) ; Err_CV.N <-c(Err_CV, length(group))
cbind(t1, Err_S.MahD, t2, Err_CV.N)}
# ---  
lda.all <- lda(sex ~ ., DS); Out_CTab(lda.all, Gr)
qda.all <- qda(sex ~ ., DS) ; Out_CTab(qda.all, Gr, type="qda")
#      stepclass()   klaR
library(klaR)  ; stepclass(sex ~ ., data=DS,  start.vars = "PC5", method="lda")
lda.step <- lda(sex ~ PC5 + PC8, DS) ; Out_CTab(lda.step, Gr)  
stepclass(sex ~ ., data=DS,  method="qda")
qda.step <- qda(sex ~ PC4, DS) ; Out_CTab(qda.step, Gr, type="qda")
#   -------------      
#    
Out_LR <- function (model, group) {
mp <- predict(model, type="response") ; posterior <- data.frame(F=1-mp, M=mp)
classified <- colnames(posterior)[apply(posterior,1,which.max)]
CTab <- table(=group, =classified) ; Err_S <- mean(group!= classified)
 return(list(CTab=CTab, Err_S=Err_S))}
summary(glm(sex ~ ., DS, family=binomial) -> lr.all) ; Out_LR(lr.all, Gr)
library(boot)  #     -   cv.glm()
cost <- function(r, pi = 0) mean(abs(r-pi) > 0.5) ; (Err_CV <- cv.glm(DS, lr.all, cost)$delta)
#      step ()
lr.step <- step(lr.all) ; Out_LR(lr.step, Gr) ; cv.glm(DS, lr.step, cost)$delta
library(e1071)    #   -------------    SVM
#      -  
CVsvm <- function(x, y) {
n <- nrow(x) ; Err_S  <- 0 ; for(i in 1:n) {svm.temp <- svm(x=x[-1,], y = y[-1],  kernel = "linear")
if (predict(svm.temp, newdata=x[i,]) != y[i]) Err_S <- Err_S +1 }  ;  Err_S/n }
svm.all <-  svm(formula = sex ~ ., data = DS,  kernel = "linear") ; CVsvm(DS[,2:12],Gr)
#   - (cross=10)      
svm.cv <- svm(formula = sex ~ ., data = DS, cross=10, kernel = "linear")
table(=Gr, =predict(svm.cv))  ; mean(predict(svm.cv) != Gr )
stepclass(sex ~ ., data=DS,  method="svmlight")  #       SVM
svm.fit <-  svm(formula = sex ~ F1+PC5+PC8, data = DS,  kernel = "linear")
table(=Gr, =predict(svm.fit))  ; mean( predict(svm.fit) != Gr )  ;  CVsvm(DS[,c(2,9,12)],Gr)
