#    6.8:   k      
VIP <-read.delim(".txt"); attach(VIP) 
library(klaR)    #  --------   
lda.all <- lda(Region ~ ., VIP); Out_CTab(lda.all, VIP$Region)  #  .  7.8
stepclass(Region ~ ., data=VIP, method="lda")
lda.step <- lda(Region ~ S.cd.+  + L. + Col,  VIP) ; Out_CTab(lda.step, VIP$Region)
#        
predplot <- function(object, x, main = "", len = 200, ...)  {
    xp <- seq(min(x[,1]), max(x[,1]), length=len) ;  yp <- seq(min(x[,2]), max(x[,2]), length=len)
    grid <- expand.grid(xp, yp)  ;  colnames(grid) <- colnames(x)[-3]
    Z <- predict(object, grid, ...) ;     zp <- as.numeric(Z$class)
    zp <- Z$post[,3] - pmax(Z$post[,2], Z$post[,1])
    plot(x[,1], x[,2], col = x[,3], pch = x[,3], main = main)
    contour(xp, yp, matrix(zp, len), add = T, levels = 0, drawlabels = FALSE)
    zp <- Z$post[,1] - pmax(Z$post[,2], Z$post[,3])
    contour(xp, yp, matrix(zp, len), add = T, levels = 0, drawlabels = FALSE)  }
#     . 6.20
lda.2 <- lda(Region ~ S.cd.+ L.,  VIP) ; qda.2 <- qda(Region ~ S.cd.+ L.,  VIP)
X2 <- data.frame(VIP[,c(4,14)], as.numeric(VIP$Region)) ; predplot (lda.2, X2)  ; predplot (qda.2, X2)
library(e1071)    #   --------    SVM
svm.cv <- svm(formula = Region ~ .,  data = VIP, cross=10, kernel = "linear")
table(=VIP$Region, =predict(svm.cv))  ; mean(predict(svm.cv) != VIP$Region )
n <- nrow(VIP) ; Err_S  <- 0 ; for(i in 1:n)   #    -
{svm.temp <- svm(formula = Region ~ .,  data = VIP[-1,], cross=10, kernel = "linear")
if (predict(svm.temp, newdata=VIP[i,]) != VIP$Region[i]) Err_S <- Err_S +1 }  ;  Err_S/n  }
library(kknn)   #   --------  -   kNN
gen.err.kknn <- numeric(50) ; mycv.err.kknn <- numeric(50) ; n <- nrow(VIP)
for (k.val in 1:50)  {  #       1  50
  pred.kknn <- kknn(Region ~ ., VIP,train=VIP,test=VIP,k=k.val,kernel="rectangular")
  gen.err.kknn[k.val] <- mean(pred.kknn$fit != VIP$Region)
for (i in 1:n)   {
    pred.kknn <- kknn(Region ~ ., train=VIP[-i,],test=VIP[i,], k=k.val, kernel="rectangular")
    mycv.err.kknn[k.val] <- mycv.err.kknn[k.val] + (pred.kknn$fit != VIP$Region[i])   }
}  ;  mycv.err.kknn <- mycv.err.kknn/n
plot(c(1:50),gen.err.kknn,type="l",xlab='k',
      ylab=' ',ylim=c(0,0.30),col="limegreen", lwd=2) 
points(c(1:50),mycv.err.kknn,type="l",col="red", lwd=2)
#         train.kknn()
train.kknn(Region ~ ., VIP, kmax = 50, kernel="rectangular")
library(nnet)   #  -------   
R <- VIP$Region ; VIP.scale <- scale(VIP[,3:15]) ; nreps<-10 ; gen.err.nnet <- numeric(10) 
#    s  ,     10 
for (s in 1:10)  {  for (k in 1:nreps) {  
  vip.nnet <- nnet(R ~ ., data = VIP.scale, size=s, trace=F) ; vip.p<-predict(vip.nnet)
  gen.err.nnet[s] <- gen.err.nnet[s]+100*sum(as.numeric(R)!=max.col(vip.p))/length(R)
  }  }  (gen.err.nnet <- gen.err.nnet/nreps)
