#      7.1:
#       
#   
library(xlsReadWrite) ; WIND <- read.xls("Time_an.xls", sheet = 3, rowNames=FALSE) 
OUT <- read.xls("D://Time_an.xls", sheet = 4, rowNames=FALSE)
#        " "
WIND.speed <- ts(WIND$, frequency=12, start=c(1961,1))
WIND.repl <- ts(WIND$, frequency=12, start=c(1961,1))
FLOW <- ts(OUT$, frequency=12, start=c(1957,1)); plot(FLOW)
save(WIND, WIND.speed, WIND.repl, OUT, FLOW, file="time_ser.RData")
#           decompose()
plot.ts(WIND.speed) ; W.decomp <- decompose(WIND.speed) ; plot(W.decomp)
W.season_adj <- (WIND.speed - W.decomp$seasonal) ; plot(W.season_adj)
#         stl ()
stmR <- stl(WIND.speed, s.window = "per", robust = TRUE)
op <- par(mar = c(0,4,0,3), oma = c(5,0,4,0), mfcol = c(4,1)) ; plot(stmR, set.pars=NULL)
 (iO <- which(stmR $ weights < 1e-8)) ; sts <- stmR$time.series
points(time(sts)[iO], 0.8* sts[,"remainder"][iO], pch = 4, col = "red") : par(op)# reset
#    --------------------     
sp.Time <- as.numeric(1:nrow(WIND)) ; sp.Speed <- WIND$
#         -
bandcrossval<- function(x,y, nstep=20,bmax=0,  L1=TRUE){
 if (bmax==0){bmax<- 1.5*sqrt(var(x))}
bstep<-  bmax/nstep ; n<- length(x); SSE<- c(1:nstep)*0 
	for (i in 1:nstep){ for (k in 2:(n-1)){
	xx<- c(x[1:(k-1)], x[(k+1):n]) ; yy<- c(y[1:(k-1)], y[(k+1):n])
      kss<- ksmooth(xx,yy,"normal",ban=(i*bstep),x.points=x[k]) 
     if(L1==FALSE) { SSE[i]<- SSE[i]+(y[k]-kss$y )^2 }
     if(L1==TRUE) { SSE[i]<- SSE[i]+ abs(y[k]-kss$y )}  }}
 k<- c(1:nstep)*bstep ; return(k[SSE==min(SSE,na.rm = TRUE)])}
#         . 7.3
bandcrossval(sp.Time, sp.Speed, L1=FALSE) ; bandcrossval(sp.Time, sp.Speed)
plot(sp.Time,sp.Speed,xlab="  1961 .",ylab=" ")
lines(ksmooth(sp.Time, sp.Speed, "normal", bandwidth=2),col="green")
lines(ksmooth(sp.Time, sp.Speed, "normal", bandwidth=7.28),col="blue",lwd=2)
lines(ksmooth(sp.Time, sp.Speed, "normal", bandwidth=21.85),col="red",lwd=2)
legend ("topright", c("band = 7.28",  "band = 21.85",  "band = 2"),col = c("blue", "red","green"), lty = 1)
#         
sp.frame <- data.frame(Time=sp.Time,Seed=WIND$)
sp.resampler <- function() {     #      
n <- nrow(sp.frame) ; resample.rows <- sample(1:n,size=n,replace=TRUE)
return(sp.frame[resample.rows,])   }
sp.spline.estimator <- function(data,m=100) {   #      
fit <- smooth.spline(x=data[,1],y=data[,2],cv=TRUE)
eval.grid <- seq(from=min(sp.Time),to=max(sp.Time),length.out=m)
return(predict(fit,x=eval.grid)$y) }
sp.spline.cis <- function(B,alpha,m=100) {  #     
spline.main <- sp.spline.estimator(sp.frame,m=m)
spline.boots <- replicate(B,sp.spline.estimator(sp.resampler(),m=m))
cis.lower <- 2*spline.main - apply(spline.boots,1,quantile,probs=1-alpha/2)
cis.upper <- 2*spline.main - apply(spline.boots,1,quantile,probs=alpha/2)
return(list(main.curve=spline.main,lower.ci=cis.lower,upper.ci=cis.upper,
x=seq(from=min(sp.Time),to=max(sp.Time),length.out=m))) }
#        -   . 7.4
sp.cis <- sp.spline.cis(B=1000,alpha=0.05)
plot(sp.Time,sp.Speed,xlab="  1961 .",ylab=" ")
abline(lm(sp.Speed ~ sp.Time),col="grey")
lines(x=sp.cis$x,y=sp.cis$main.curve,col="red",lwd=2)
lines(x=sp.cis$x,y=sp.cis$lower.ci,col="blue",lty=2)
lines(x=sp.cis$x,y=sp.cis$upper.ci,col="blue",lty=2)
# -------------------------------------------------------------------------
#      
library (cpm)
 cpm.ts <- function(x, cpmType)  {
#    :  cpmType = "Mann-Whitney" , "Mood"
#                   "Kolmogorov-Smirnov","Cramer-von-Mises", "Lepage"  .
cpm <- makeChangePointModel(cpmType=cpmType, ARL0=500) ;  i <- 0
 while (i < length(x)) {
   i <- i + 1 ; cpm <- processObservation(cpm,x[i])
   if (changeDetected(cpm) == TRUE)    {
      detectiontimes <- c(detectiontimes,i);  Ds <- getStatistics(cpm) 
      tau <- which.max(Ds)
      if (length(changepoints) > 0) { tau <- tau + changepoints[length(changepoints)] }
      changepoints <- c(changepoints,tau) ; cpm <- cpmReset(cpm)
      i <- tau   }  }  
return (list(cpmType=cpmType, changepoints = changepoints, detectiontimes = detectiontimes)) 
}
cpm.ts(sp.Speed, cpmType="Mann-Whitney") ; cpm.ts(sp.Speed, cpmType="Lepage")
library(tree)    #        . 7.5
hump<-function(x,y){  model<-tree(y~x) ; xs<-grep("[0-9]",model[[1]][[5]])
xv<-as.numeric(substring(model[[1]][[5]][xs],2,10))
xv<-xv[1:(length(xv)/2)] ; xv<-c(min(x),sort(xv),max(x))
yv<-model[[1]][[4]][model[[1]][[1]]=="<leaf>"]
plot(x,y, xlab=deparse(substitute(x)),ylab=deparse(substitute(y)))
i<-1 ; j<-2 ; k<-1 ; b<-2*length(yv)+1 ; for (a in 1:b){ lines(c(xv[i],xv[j]),c(yv[k],yv[i]),lwd=2)
if(a%%2==0){ j<-j+1 ;k<-k+1 }
else{i<-i+1} }  
return(xv)}
TimeGroup <- hump(sp.Time, sp.Speed) ; lines(lowess(sp.Time, sp.Speed, f=.25), col = "grey",lwd=2)
sp.factor <- rep(4, length(sp.Time)) ; sp.factor[sp.Time[sp.Time<TimeGroup[4]]] <- 3
sp.factor[sp.Time[sp.Time<TimeGroup[3]]] <- 2 ;  sp.factor[sp.Time[sp.Time<TimeGroup[2]]] <- 1
mean(sp.Speed[sp.factor==c(1,4)])  ; mean(sp.Speed[sp.factor==c(2,3)])  
sp.factor <- as.factor(sp.factor) ; tapply(sp.Speed,sp.factor,mean)
summary(mod<-aov(sp.Speed~sp.factor)  #     
#      HSD,     
(mod.HSD <- TukeyHSD(mod)) ;  plot(mod.HSD)
#      
source("uis.r") ; K.tabl <- uis(sp.Speed)
write.table(K.tabl, file="clipboard", sep="\t", col.names=NA)
# -------------------------------------------------------------------------
#          decompose()
FLOW.d <- decompose(FLOW) ; FLOW.d$figure ; plot(FLOW.d$trend) 
#       
library(pastecs) ; trend.test(FLOW.d$trend, R=1)   #     
test.Sp <- trend.test(FLOW, R=1000) ; plot(test.Sp) ; test.Sp$p.value   #    
#     
local.trend(FLOW) ; identify(local.trend(FLOW)) ; T=c(1: nrow(FLOW))
fit2 <- lm(FLOW.d$trend[1:255]~T[1:255]) ; summary(fit2) 
fit3 <- lm(FLOW.d$trend[255:384]~T[255:384]) ; summary(fit3)
plot(T,FLOW.d$trend, type="l") 
points(T[7:255], predict(fit2), type="l", col="red", lwd=2)
points(T[255:378], predict(fit3), type="l", col="red", lwd=2)
