#      7.5:
#     
MOL <- read.xls("Mol.xls", sheet = 1, rowNames=FALSE) ; attach (MOL) 
library(spatstat)  #       spatstat 
#   ,        
q.point <- function(xq, yq, nq) {
xp <- matrix(rep(0, nq*2), ncol=2) ; xp[,1] <- 1.5*(xq - 1) + runif(nq,0,1.5)
xp[,2] <- 1.5*(yq - 1) + runif(nq,0,1.5)  ; return (xp) }
df.point <- function(df, cx, cy, cm) {
df.nz <- subset(df, df[,cm]>0, select = c(cx,cy,cm)) ; x <- q.point(df.nz[1,1],df.nz[1,2], df.nz[1,3])
for (i in 2:nrow(df.nz)) {x <- rbind(x, q.point(df.nz[i,1],df.nz[i,2], df.nz[i,3])) }
colnames(x) <- c("X","Y") ; return( transform(as.data.frame(x),
 spec=substr(colnames(df)[cm],1,2), age=substr(colnames(df)[cm],4,6))) }
#   ppp (point pattern)
p.Mc <- df.point(MOL,cm=5,cx=1,cy=2); p.Mc <-  rbind(p.Mc, df.point(MOL,cm=6,cx=1,cy=2))
ppp.Mc <- ppp(x=p.Mc$X, y=p.Mc$Y, marks=data.frame(spec=p.Mc$spec, age=p.Mc$age ),
 window=owin(c(0, 30), c(0, 12)))
#     bandwidth    Silverman
sigma<-(sd(ppp.Mc$x)+sd(ppp.Mc$y))/2 ; iqr<-(IQR(ppp.Mc$x)+IQR(ppp.Mc$y))/2 
bandwidth<-0.9*min(sigma, iqr)*ppp.Mc$n^(-1/5)
Mc.intensity <- density.ppp(ppp.Mc, sigma=bandwidth)
plot(Mc.intensity) ; points(ppp.Mc, pch=19, cex=0.6)  #   . 7.15 
axis(side=1, at = seq(0, 30, 2), las = 1, pos = 0)   #  
axis(side=2, at = seq(0, 12, 2), las = 1, pos = 0)   # 
ppp.Temp <- ppp.Mc ; marks(ppp.Temp) <- ppp.Mc$marks$age   #   
p <- relrisk(ppp.Temp, 0.5) #     juv  . 7.15  
plot(p,col=colorRampPalette(c("antiquewhite", "aquamarine3","navyblue"))(100))
contour(p,nlevels=5, lwd=seq(from=0.1, to=3, length.out=5),add=T)  #  
p.Bc <- df.point(MOL,cm=3,cx=1,cy=2); p.Bc <-  rbind(p.Mc, df.point(MOL,cm=4,cx=1,cy=2))
ppp.Bc <- ppp(x=p.Bc$X, y=p.Bc$Y, marks=data.frame(spec=p.Bc$spec, age=p.Bc$age ),
                  window=owin(c(0, 30), c(0, 12)))
#   
ppp_qu<-quadrats(ppp.Bc, nx = 20, ny = 8) ; xgrid <-  ppp_qu$xgrid; ygrid <-  ppp_qu$ygrid
quadcount <- quadratcount(ppp.Bc, tess=ppp_qu) #     
image(xgrid, ygrid,      t(quadcount[order(1:8, decreasing = T), ]),
 col = colorRampPalette(c("white", "green"))(15),axes=F)
plot(quadcount, add=T, cex=0.9)   #   . 7.15
#   plot(ppp.Bc, which.marks="age", chars=c(19, 24), cex=0.5, add=T)
#   K  L   
Mc.Kfv <- envelope(unmark(ppp.Mc), fun=Kinhom) ; plot(Mc.Kfv); plot(pcf(Mc.Kfv))
Mc.Lfv <- envelope(unmark(ppp.Mc), fun=Linhom) ; plot(Mc.Lfv)
#  K-      
df.all <-  rbind(p.Mc[,-4], p.Bc[,-4])  ; ppp.all <- ppp(x=df.all$X, y=df.all$Y,
 marks=data.frame(spec=df.all$spec), window=owin(c(0, 30), c(0, 12)))
plot(Kcross.inhom(ppp.all)); all.Cfv <- envelope(ppp.all, fun=Kcross.inhom, method="b") ; plot(all.Cfv)
#  -  CSR      
quadrat_test_result <- quadrat.test(ppp.Bc, nx = 20, ny = 8,alternative="clustered")
 quadrat_test_result$observed 	       #     
round(quadrat_test_result$expected , 2)   #   
quadrat.test(ppp.Mc[ppp.Mc$marks$age=="juv"],nx = 20, ny = 8) #     
kstest(ppp.Bc, "x") ; kstest(ppp.Bc, "y")   #   -
#         CSR 
Morisita <- function (N, n=length(N)) {
NS <- sum(N) ; IM <- n*sum(N*(N-1))/NS/(NS-1) #  
DI <- (qchisq(c(0.025,0.975),(n-1))+NS-n)/(NS-1) #   
return (list(IM=IM, DI=DI)) }
#   .   ,    
IM.randtest <- function( N, lx, ly,  nx, ny, Nperm) {  
PermArray <- as.numeric(rep(NA, Nperm)) ; lambda <- sum(N)/lx/ly
for (i in 1:Nperm) { pp <- rpoispp(lambda, win=owin(c(0, lx), c(0, ly))) #  CSR
      quadcount <- quadratcount(pp, nx=nx, ny=ny) 
      PermArray[i] <- Morisita(as.data.frame(quadcount)$Freq)$IM }
return (RandRes(Morisita(N)$IM, PermArray, Nperm)) }
source("print_rezult.r")  #    
IM.randtest((MOL$Mc_ad+MOL$Mc_juv), 30, 12, 20, 8, 1000)
J.index <- function(x){(var(x)/mean(x)-1)/mean(x)}  #    J 
library(bootstrap)   #     J    
N <- MOL$Mc_juv ; results <- jackknife(N,J.index) ; J.index(N); results$jack.bias ; results$jack.se 
tc <- qt(0.975, length(N)-1)  #     Jackknife-
Jl <- J.index(N) - results$jack.bias - tc* results$jack.se ;  
Ju <- J.index(N) - results$jack.bias + tc* results$jack.se
#    C        
C.index <- function(N1, N2){cov(N1, N2)/mean(N1)/mean(N2)}  #   C-
C.randtest <- function( dfa, nx, ny, Nperm) { 
PermArray <- as.numeric(rep(NA, Nperm)) ; types <- names(dfa) ; nal <- colSums(dfa)
for (i in 1:Nperm) { ppp <- rmpoint(nal, 1, types=types ) #  CSR
  quadcount.N1 <- quadratcount(ppp[ppp$marks==types[1]], nx=nx, ny=ny)
  quadcount.N2 <- quadratcount(ppp[ppp$marks==types[2]], nx=nx, ny=ny)
  PermArray[i] <- C.index(as.data.frame(quadcount.N1)$Freq, as.data.frame(quadcount.N2)$Freq)  }
return (RandRes(C.index(dfa[,1], dfa[,2]), PermArray, Nperm)) }
dfa <- data.frame(Bc=MOL$Bc_ad+MOL$Bc_juv, Mc = MOL$Mc_ad+MOL$Mc_juv)
C.randtest(dfa, 20, 8, 1000) #    C     
save(MOL, file="MOL.RData")
