#      7.6:
#        
load (file="MOL.RData");  library(spdep) ; library(vegan) ; library(gstat)
MOL.xy <- data.frame(x=1.5*(MOL[,1] - 1) + 0.75,  y=1.5*(MOL[,2] - 1) + 0.75)
MOL.sp <- data.frame(Bc = MOL[,3]+MOL[,4], Mc = MOL[,5]+MOL[,6])
#        ,    
MOL.Bc <- subset(cbind(MOL.xy, MOL[,3:4]), Bc_ad > 0) ; D.mat = as.matrix(dist(MOL.Bc[,1:2]))
plot(MOL.Bc[,1:2], type="p", pch=21, bg="green", cex=5*(MOL.Bc[,3])/max((MOL.Bc[,3])))
n = nrow(MOL.Bc); thresh = sqrt(2*1.5^2)   #        2.12 
for(j in 1:(n-1)) {    for(jj in (j+1):n)  {    if((D.mat[j,jj]<=thresh)&(D.mat[j,jj]>0)) 
lines(c(MOL.Bc[j,1], MOL.Bc[jj,1]), c(MOL.Bc[j,2], MOL.Bc[jj,2])) } }
#     
MOL.h <- decostand (MOL.sp, "hellinger") #   
MOL.poly <- poly(as.matrix(MOL.xy), degree=3, raw=TRUE)
colnames(MOL.poly) <- c("X","X2","X3","Y","XY","X2Y","Y2","XY2","Y3")
#        
MOL.trend <- lm(as.matrix(MOL.h) ~ ., data=as.data.frame(MOL.poly)); summary(MOL.trend) 
install.packages("packfor", repos="http://R-Forge.R-project.org")
forward.sel(MOL.h$Bc, MOL.poly, adjR2thresh=0.2313)
MOL.Bc.trend <-lm(MOL.h$Bc ~ X + X2 + XY + Y, data=as.data.frame(MOL.poly)) 
forward.sel(MOL.h$Mc, MOL.poly, adjR2thresh=0.1291)
MOL.Mc.trend <-lm(MOL.h$Mc ~ X + XY , data=as.data.frame(MOL.poly)) 
summary(MOL.Bc.trend)  ;  summary(MOL.Mc.trend)
#     
MOL.h.det <- as.data.frame(cbind(resid(MOL.Bc.trend),resid(MOL.Mc.trend))) 
#       
hgt.pal <- function(z) {ny=ncol(z); nx=nrow(z) 
 hgt <- 0.25 * (z[-nx,-ny] + z[-1,-ny] + z[-nx,-1] + z[-1,-1])
 hgt <- (hgt - min(hgt))/ (max(hgt) - min(hgt)) ; return (hgt) }
z <- matrix(MOL.Bc.trend$fit, ncol=8, nrow=20)
persp(unique(MOL.xy$x),unique(MOL.xy$y), z, theta = -60, phi = 25, xlab = "x", ylab = "y", zlab = "n", 
ticktype = "detailed", col = gray(1 - hgt.pal(z)))
#      B.cylindrica   
MOL.v <- cbind(MOL.xy,MOL.sp) ; coordinates(MOL.v)=~x+y
Bc.v <- variogram(Bc ~ 1, MOL.v, cutoff=15, width=1.5) 
plot(Bc.v$dist,Bc.v$gamma, ylim=c(2.5,7.5), type="b", lwd=2)
for (i in 1:100) {   #        
Bc.vr <- variogram(sample(MOL.v$Bc,nrow(MOL.v)) ~ 1, MOL.v, cutoff=15, width=1.5)
lines(Bc.vr$dist,Bc.vr$gamma, col="grey") } 
Bc.v <- variogram(Bc ~ 1, MOL.v, cutoff=12, width=1.5,map=TRUE) ; 
plot(Bc.v,col.regions=gray((16:0)/16)) #     
#           
MOL.dt.v <- cbind(MOL.xy, MOL.h.det) ; coordinates(MOL.dt.v)=~x+y
Bc.dt.v <- variogram(BcDt ~ 1, MOL.dt.v, cutoff=15, width=1.5) 
 Mc.mv <- vgm(0.08, "Sph", 5, nug = 0.02)  #   
plot(Bc.dt.v, model = fit.variogram(Bc.dt.v, model = Bc.mv), col=1, ylim=c(0.06,0.105), lwd=2)
#       
nb1 <- dnearneigh(as.matrix(MOL.xy), 0,1.5)
Bc.correlog <- sp.correlogram(nb1, MOL.sp$Bc, order=8, method="I",zero.policy=TRUE)
Bc.det.cor <- sp.correlogram(nb1, as.vector(MOL.h.det[,1]), order=8, method="I", zero.policy=TRUE)
print(Bc.correlog, p.adj.method="bonferroni") ; print(Bc.det.cor, p.adj.method="bonferroni")
Mc.correlog <- sp.correlogram(nb1, MOL.sp$Mc, order=8, method="I",zero.policy=TRUE)
plot(Bc.correlog) ; plot(Mc.correlog)
#   
MOL.h.D1 <- dist(MOL.h.det); 
(MOL.man_cor <- mantel.correlog(MOL.h.D1, XY=MOL.xy, nperm=999)) ; plot(MOL.man_cor)
MOL.man_cor$n.class ; MOL.man_cor$break.pts
