
 # -------------------------------------------------------------------------
 #        
 uis <- function(Y)  {
 #  3 :  -,    
 # -------------------------------------------------------------------------
set.seed(1946)
K.cox = uis.vec(Y, "cox.test")
K.abbe = uis.vec(Y, "abbe.test")
K.naka = uis.vec(Y, "naka.test")
K.tabl <- data.frame(Y, K.cox, K.abbe, K.naka)
return (K.tabl)
}
#          krit 
uis.vec <- function(Y, krit) {
Nim=length(Y)
K <- rep(0, Nim)  #      
kpa = 0   #   
nmin =5    #   
i1 = 1
repeat{
  kpa = kpa + 1
  i2 = Inter(Y, i1, Nim, nmin, krit = krit)
  K[i1:i2] = kpa
  if ((Nim-i2)<nmin) break
  i1 = i2 + 1
}
return (K) 
}
#      i1         krit 
#    ,  
Inter <- function(Y, i1, Nim, nmin, krit) {
j = i1 + nmin 
FUN <- match.fun(krit)
repeat{
 p <- FUN(Y[i1:j])
 if (p<0.05) break
 j = j + 1
  if (Nim<j) break
}
return (j -1)
}
#      
#  p- (    )
ABBE <- function (y,N) {
sr <-sum((y[1:(N-1)]-y[2:N])^2)/2/(N-1)
k <- sr/var(y)
return (k) } 
abbe.test <- function (y, R=200) {
 N = length(y)
kA <- ABBE(y,N)
pA = 1 
for (i in 1:R) {
Yrand <- sample(y)
if (ABBE(Yrand,N) < kA) {pA = pA + 1}
}
    return(pA/R)
  }
#       
NAKA <- function (y,N) {
Med=median(y)
k <- 1.048*median(abs(y[1:(N-1)]-y[2:N]))/1.482/median(abs(y-Med))
return (k) } 
naka.test <- function (y, R=200) {
 N = length(y)
kN <- NAKA(y,N)
pN = 1
for (i in 1:R) {
Yrand <- sample(y)
if (NAKA(Yrand,N) < kN) {pN = pN + 1}
}
    return(pN/R)
  }
#   -   
cox.stuart.test =
function (x)
{
  method = "Cox-Stuart test for trend analysis"
  leng = length(x)
  apross = round(leng) %% 2
  if (apross == 1) {
    delete = (length(x)+1)/2
    x = x[ -delete ] 
  }
  half = length(x)/2
  x1 = x[1:half]
  x2 = x[(half+1):(length(x))]
  difference = x1-x2
  signs = sign(difference)
  signcorr = signs[signs != 0]
  pos = signs[signs>0]
  neg = signs[signs<0]
  if (length(pos) < length(neg)) {
    prop = pbinom(length(pos), length(signcorr), 0.5)
    names(prop) = "Increasing trend, p-value"
    rval <- list(method = method, statistic = prop)
    class(rval) = "htest"
    return(rval)
  }
  else {
    prop = pbinom(length(neg), length(signcorr), 0.5)
    names(prop) = "Decreasing trend, p-value"
    rval <- list(method = method, statistic = prop)
    class(rval) = "htest"
    return(rval)
  }
}
cox.test <- function (y) {
ts <- cox.stuart.test(y)
return (ts$statistic)
}


# library(pastecs)
#  K.spir = uis.vec(Y, "spir.test")
#      
#   -    
spir.test <- function (y,R=200) {
ts <- trend.test(y, R=R)
return (ts$p.value)
}




